#include <config.h>
#include <nessus-devel.h>
#include <nessuslib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>  

#define NAME "icat-cgi tester"
#define DESC "This plugin determines the presence of the 'icat' cgi \
The 'icat' cgi allows a remote user to view any file on a WindowsNT \
system"
#define COPYRIGHT "ported by Renaud Deraison"
#define SUMM "determines the presence of the 'icat' cgi"


int plugin_init(struct arglist *desc);
int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_GATHER_INFO);
	plug_set_family(desc, "CGI abuses");
	return(0);
}



int plugin_run(struct arglist * args);	
int plugin_run(struct arglist * args)
{
	if(host_get_port_state(args, 80)<=0)return(0);
	
	if(is_cgi_installed(args, "icat"))
	  post_hole(args, 80, "The 'icat' cgi is installed\nAny file may be viewed
Solution : contact the vendor for a patch");
	return(0);
}

